<?php
//client CAS utilis par index.php pour la connexion et logout.php pour la dconnexion
$envole_cas = null;

//prsent dans l'include_path du php.ini (/usr/share/php)
include_once("CAS-1.3.1/eoleCAS.php");
include_once("configCAS/cas.inc.php");

//instanciation du client CAS
function envole_cas_instance()
    {
    global $envole_cas;
    if(empty($envole_cas))
        {
        $envole_cas = new eolephpCAS();
        //dernier argument  "true" provoque une problme de session dans Grr qui utilise sa propre session au nom de "GRR"
        $envole_cas->client(__CAS_VERSION,__CAS_SERVER,__CAS_PORT,__CAS_FOLDER,false);
        $envole_cas->setNoClearTicketsFromUrl();  // Maj pour phpCAS 1.3.1
        if(method_exists($envole_cas,'setNoCasServerValidation')) $envole_cas->setNoCasServerValidation();
        if(method_exists($envole_cas,'EoleLogoutRequests')) $envole_cas->EoleLogoutRequests(false);
        }
    }

//vrifier l'authentification
function envole_cas_check()
    {
    global $envole_cas;

    //instanciation
    envole_cas_instance();

    return $envole_cas->isAuthenticated();
    }

//est-ce bien $login qui est authentifi ?
function envole_cas_user($login)
    {
    global $envole_cas;

    return ($login==$envole_cas->getUser());
    }

//authentification et rcupration des informations sur l'utilisateur
function envole_cas_auth()
    {
    global $envole_cas;

    //instanciation
    envole_cas_instance();

    //forcer  redemander les infos auprs du serveur CAS (au lieu de les lire en session alors que ce serait les infos d'une autre appli...)
    if(isset($_SESSION["phpCAS"])) unset($_SESSION["phpCAS"]);

    //authentification
    $envole_cas->forceAuthentication();

    //rcupration des informations de l'utilisateur
    return $envole_cas->getDetails();
    }

//dconnexion
function envole_cas_logout()
    {
    global $envole_cas;

    //instanciation
    envole_cas_instance();

    //procdure de dconnexion du serveur CAS
    $domaine = (isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS'])) ? "https://" : "http://";
    if(empty($_SERVER['SERVER_NAME'])) $domaine .= $_SERVER['HTTP_HOST'];
    else $domaine .= $_SERVER['SERVER_NAME'];
    $url = $domaine."/grr/logout.php?auto=0&envole_logout"; //variable "envole_logout" pour identifier la redirection
    $service = $domaine."/grr/index.php";
    $envole_cas->logout(array("service"=>$service));
    }
?>
